'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var root = require('./root.js');
var element = require('./element.js');
var mount = require('./mount.js');
var destroy = require('./destroy.js');
var toReactString = require('./toReactString.js');

// As of React 18, we must specifically tell React it is operating in a unit-test-like environment
// This enables the use of act() and ensures that warnings will be logged on unwrapped updates
// See: https://github.com/reactwg/react-18/discussions/102
// See: https://reactjs.org/blog/2022/03/08/react-18-upgrade-guide.html#configuring-your-testing-environment
globalThis.IS_REACT_ACT_ENVIRONMENT = true;

exports.Root = root.Root;
exports.Element = element.Element;
exports.CustomRoot = mount.CustomRoot;
exports.createMount = mount.createMount;
exports.mount = mount.mount;
exports.destroyAll = destroy.destroyAll;
exports.nodeName = toReactString.nodeName;
exports.toPropString = toReactString.toPropString;
exports.toReactString = toReactString.toReactString;
