import React from 'react';
import { isPortal } from 'react-is';

class TestWrapper extends React.Component {
  constructor(...args) {
    super(...args);
    this.state = {};
    // eslint-disable-next-line @shopify/react-prefer-private-members
    this.rootRef = null;
    this.setRef = ref => {
      this.rootRef = ref;
    };
  }
  // eslint-disable-next-line @shopify/react-prefer-private-members
  setProps(props) {
    this.setState({
      props
    });
  }
  render() {
    const {
      props
    } = this.state;
    const {
      children,
      render
    } = this.props;
    const rootElement = isPortal(children) ? children : /*#__PURE__*/React.cloneElement(children, props);
    return render( /*#__PURE__*/React.createElement(TestInnerWrapper, {
      ref: this.setRef
    }, rootElement));
  }
}
class TestInnerWrapper extends React.Component {
  render() {
    return this.props.children;
  }
}

export { TestWrapper };
